question=1;
%
if question==1
    %
    phi_1=rand*2*pi;
    A1=1;
    phi_2=rand*2*pi;
    sigma_b=0.001;
    %
    Te=1/nu_e;
    vec_t=Te:Te:T;
    %
    x=sin(2*pi*nu1*vec_t+phi_1)+A2*sin(2*pi*nu2*vec_t+phi_2);
    %
    if A2==0
        disp('x(t) est une sinusoide')
    else
        disp('x(t) est la somme de deux sinusoides')
    end
    %
    if sigma_b>0
        disp('x est bruite')
    end
    x=x+sigma_b*randn(size(x));
    %
    if choix_blackman==1
        disp('fenetre de ponderation active')
        N=length(x);
        w=blackman(N)';
        x=x.*w;
    end
    %
    if choix_zero_padding==1
        disp('zeropadding actif')
        N=length(x);
        x=[x zeros(1,N*8)];
    end
    %
    N=length(x);
    vec_t=Te*(1:N);
    N=length(vec_t);
    delta_nu=nu_e/N;
    vec_nu=(0:N-1)*delta_nu;
    %
    X=fft(x);
    %
    figure(1+10*choix_zero_padding+100*choix_blackman);
    subplot(2,1,1)
    plot(vec_t,x,'.')
    title('x_n : signal echantillonne [V]')
    xlabel('n T_e [s]')
    set(gca,'FontSize',14)
    set(gca,'ylim',[-1 1]*1.01)
    grid on
    %
    subplot(2,1,2)
    plot(vec_nu,abs(X),'.')
    title('X_k : transformee de Fourier discrete de x_n [V]')
    xlabel('k \Delta_\nu [Hz]')
    set(gca,'FontSize',14)
    set(gca,'xlim',[0 nu_e/2])
    set(gca,'yscale','log')
    grid on
    %
elseif question==2
    %
    % frequence d'echantillonnage
    f_e=100;
    t_e=1/f_e;
    %
    % generation des signaux
    t=0:t_e:20;
    %
    if choix_signal==1
        %
        alpha1=1/10;
        beta1=3;
        t_1=7;
        nu_1=35;
        y1=exp(-pi*alpha1*(t-t_1).^2).*cos(2*pi*(beta1*(t-t_1).^2/2+nu_1*(t-t_1)));
        s=y1;
    elseif choix_signal==2
        %
        alpha1=1/10;
        alpha2=1/10;
        beta1=3;
        beta2=3;
        %
        t_1=7;
        t_2=7;
        nu_1=35;
        nu_2=28;
        y1=0.05*exp(-pi*alpha1*(t-t_1).^2).*cos(2*pi*(beta1*(t-t_1).^2/2+nu_1*(t-t_1)));
        y2=exp(-pi*alpha2*(t-t_2).^2).*cos(2*pi*(beta2*(t-t_2).^2/2+nu_2*(t-t_2)));
        %
        s=y1+y2+0.01*randn(size(y1));
    elseif choix_signal==3
        %
        t_1=7;
        t_2=7;
        nu_1=29;
        nu_2=28;
        %
        y1=0.95*cos(2*pi*nu_1*(t-t_1));
        y2=cos(2*pi*nu_2*(t-t_2));
        s=y1+y2+0.01*randn(size(y1));
    elseif choix_signal==4
        load handel
        s=y(1:60000)/2;
        f_e=Fs;t_e=1/f_e;
        N=length(s);
        t=(1:N)*t_e;
    end
    %
    figure(choix_signal+10*strcmp(fenetre,'blackman'))
    %
    % representation en temps
    h1=subplot('position',[0.35 0.1 0.6 0.12]);
    plot(t,s)
    set(gca,'fontsize',14)
    grid on
    set(gca,'ylim',[-1 1])
    set(gca,'xlim',[t(1) t(end)])
    %
    % representation en frequence
    S=abs(fft(s));
    F=linspace(0,f_e,length(S));
    h2=subplot('position',[0.05 0.35 0.15 0.55]);
    plot(F,S)
    set(gca,'fontsize',14)
    set(gca,'CameraUpVector',[1 0 0])
    set(gca,'xlim',[0 f_e/2])
    grid on
    %
    % representation en temps-frequence
    lgf=round(length(s)/10);
    %
    if strcmp(fenetre,'rectangle')
        w=boxcar(lgf);
    else
        w=blackman(lgf);
    end
    noverlap=floor(lgf*9/10);
    nfft=2^(2+nextpow2(lgf));
    %
    [ima,freq_ima,time_ima]=spectrogram(s,w,noverlap,nfft,f_e);
    %
    ima=abs(ima).^(1/4);
    %
    h3=subplot('position',[0.35 0.35 0.6 0.55]);
    imagesc(time_ima,freq_ima,ima)
    set(gca,'fontsize',14)
    axis xy
    xlabel('temps (s)')
    ylabel('frequence (Hz)')
    %
end
